/*
 File: lr1_k_phrase_th.cpp
 Date and Time: Fri Jan 30 18:55:15 2015 
*/
#include "lr1_k_phrase_th.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_lr1_k_phrase_th;// grammar's ns
// first set terminals
fsm_rules_reuse_table_type::fsm_rules_reuse_table_type(){
 no_rules_entries_ = 23;
 per_rule_s_table_[0] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[1] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[2] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[3] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[4] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[5] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[6] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[7] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[8] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[9] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[10] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[11] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[12] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[13] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[14] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[15] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[16] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[17] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[18] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[19] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[20] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[21] =  new Per_rule_s_reuse_table();
 per_rule_s_table_[22] =  new Per_rule_s_reuse_table();
}
  Clr1_k_phrase_th::
  Clr1_k_phrase_th()
    :yacco2::CAbs_fsm
      ("lr1_k_phrase_th.lex"
      ,"1.0"
      ,"22 mar 2004"
      ,false
      ,"Parse lr1 k symbols phrase."
      ,"Fri Jan 30 18:55:15 2015 "
      ,S1_Clr1_k_phrase_th){
    
    lr1_k_phrase_ = 0;
  
  }
 
Clr1_k_phrase_th::~Clr1_k_phrase_th(){

  for(int x = 0;x < 23;++x){
   ///delete fsm_rules_reuse_table.per_rule_s_table_[x];
  }
} 

  bool Clr1_k_phrase_th::failed(){
      return false;
  }
  void Clr1_k_phrase_th::op(){
    if(lr1_k_phrase_ != 0){
      delete lr1_k_phrase_;
      lr1_k_phrase_ = 0;
    }
    lr1_k_phrase_ = new T_lr1_k_phrase;
    lr1_k_phrase_->set_rc(*parser__->start_token__,__FILE__,__LINE__);
    AST* t = new AST(*lr1_k_phrase_);
    lr1_k_phrase_->phrase_tree(t);
  
}
int Clr1_k_phrase_th::rhs_to_rules_mapping_[51] = {
 -1
 ,0 // subrule 1 for rule 1
 ,1 // subrule 2 for rule 2
 ,1 // subrule 3 for rule 2
 ,2 // subrule 4 for rule 3
 ,2 // subrule 5 for rule 3
 ,3 // subrule 6 for rule 4
 ,4 // subrule 7 for rule 5
 ,5 // subrule 8 for rule 6
 ,5 // subrule 9 for rule 6
 ,5 // subrule 10 for rule 6
 ,6 // subrule 11 for rule 7
 ,6 // subrule 12 for rule 7
 ,6 // subrule 13 for rule 7
 ,7 // subrule 14 for rule 8
 ,7 // subrule 15 for rule 8
 ,8 // subrule 16 for rule 9
 ,8 // subrule 17 for rule 9
 ,8 // subrule 18 for rule 9
 ,9 // subrule 19 for rule 10
 ,9 // subrule 20 for rule 10
 ,9 // subrule 21 for rule 10
 ,10 // subrule 22 for rule 11
 ,11 // subrule 23 for rule 12
 ,11 // subrule 24 for rule 12
 ,11 // subrule 25 for rule 12
 ,12 // subrule 26 for rule 13
 ,12 // subrule 27 for rule 13
 ,12 // subrule 28 for rule 13
 ,13 // subrule 29 for rule 14
 ,13 // subrule 30 for rule 14
 ,13 // subrule 31 for rule 14
 ,14 // subrule 32 for rule 15
 ,14 // subrule 33 for rule 15
 ,15 // subrule 34 for rule 16
 ,15 // subrule 35 for rule 16
 ,16 // subrule 36 for rule 17
 ,17 // subrule 37 for rule 18
 ,17 // subrule 38 for rule 18
 ,17 // subrule 39 for rule 18
 ,18 // subrule 40 for rule 19
 ,18 // subrule 41 for rule 19
 ,18 // subrule 42 for rule 19
 ,19 // subrule 43 for rule 20
 ,19 // subrule 44 for rule 20
 ,20 // subrule 45 for rule 21
 ,20 // subrule 46 for rule 21
 ,21 // subrule 47 for rule 22
 ,21 // subrule 48 for rule 22
 ,22 // subrule 49 for rule 23
 ,22 // subrule 50 for rule 23
}; 
Rlr1_k_phrase::Rlr1_k_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rlr1_k_phrase",0,Clr1_k_phrase_th::R_Rlr1_k_phrase_,P,false,false){
}

void Rlr1_k_phrase::sr1(){
  
      Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
      RSVP(fsm->lr1_k_phrase_);
      fsm->lr1_k_phrase_ = 0;
    
}

Ropen_par::Ropen_par(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Ropen_par",0,Clr1_k_phrase_th::R_Ropen_par_,P,false,false){
}

void Ropen_par::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_open_parenthesis;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rclose_par::Rclose_par(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rclose_par",0,Clr1_k_phrase_th::R_Rclose_par_,P,false,false){
}

void Rclose_par::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_close_parenthesis;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rparameters::Rparameters(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rparameters",0,Clr1_k_phrase_th::R_Rparameters_,P,false,false){
}

Rfilename_phrase::Rfilename_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfilename_phrase",0,Clr1_k_phrase_th::R_Rfilename_phrase_,P,false,false){
}

Rfilename::Rfilename(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfilename",0,Clr1_k_phrase_th::R_Rfilename_,P,false,false){
}

void Rfilename::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_filename_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfilename::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_filename_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rfilename_id::Rfilename_id(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rfilename_id",0,Clr1_k_phrase_th::R_Rfilename_id_,P,false,false){
}

void Rfilename_id::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->lr1_k_phrase_->filename_id(sf->p2__);
      
}

void Rfilename_id::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_filename_id_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rfilename_id::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_filename_id_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rnamespace_phrase::Rnamespace_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rnamespace_phrase",0,Clr1_k_phrase_th::R_Rnamespace_phrase_,P,false,false){
}

void Rnamespace_phrase::sr2(){
  
        CAbs_lr1_sym* sym = new Err_no_comma_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rnamespace::Rnamespace(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rnamespace",0,Clr1_k_phrase_th::R_Rnamespace_,P,false,false){
}

void Rnamespace::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_namespace_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rnamespace::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_namespace_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rnamespace_id::Rnamespace_id(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rnamespace_id",0,Clr1_k_phrase_th::R_Rnamespace_id_,P,false,false){
}

void Rnamespace_id::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_identifier* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->lr1_k_phrase_->namespace_id(sf->p2__);
      
}

void Rnamespace_id::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_namespace_id_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

void Rnamespace_id::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_namespace_id_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rsym_defs_phrase::Rsym_defs_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_defs_phrase",0,Clr1_k_phrase_th::R_Rsym_defs_phrase_,P,false,false){
}

Rsym_def::Rsym_def(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_def",0,Clr1_k_phrase_th::R_Rsym_def_,P,false,false){
}

void Rsym_def::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_terminal_def* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
	  sf->p2__->classification(T_terminal_def::lrk);
      CAbs_lr1_sym* r = fsm->lr1_k_phrase_->add_t_to_alphabet(sf->p2__,rule_info__.parser__);
      if(r == 0) return;
      RSVP(r);
      rule_info__.parser__->set_stop_parse(true);
    
}

void Rsym_def::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        sf->p2__->set_auto_delete(true);
        CAbs_lr1_sym* sym = new Err_no_sym_defs_present;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rsym_def::sr3(){
  
        CAbs_lr1_sym* sym = new Err_no_sym_defs_present;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
    
}

Rsym_def1s::Rsym_def1s(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_def1s",0,Clr1_k_phrase_th::R_Rsym_def1s_,P,false,false){
}

Rsym_def1::Rsym_def1(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rsym_def1",0,Clr1_k_phrase_th::R_Rsym_def1_,P,false,false){
}

void Rsym_def1::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_terminal_def* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
	  sf->p2__->classification(T_terminal_def::lrk);
      CAbs_lr1_sym* r = 
	fsm->lr1_k_phrase_->add_t_to_alphabet(sf->p2__,rule_info__.parser__);
      if(r != 0){
        RSVP(r);
        rule_info__.parser__->set_stop_parse(true);
        return;
      }
    
}

void Rsym_def1::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Err_no_terminal_key_present* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
        RSVP(sf->p2__);
        fsm->lr1_k_phrase_ = 0;
        rule_info__.parser__->set_stop_parse(true);
      
}

void Rsym_def1::sr3(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
      using namespace NS_yacco2_T_enum;
       int id = sf->p2__->enumerated_id__;
       if(id >= T_Enum::start_ERR && id <= T_Enum::end_ERR){
         RSVP(sf->p2__);
         rule_info__.parser__->set_stop_parse(true);
       }else{
        CAbs_lr1_sym* sym = new Err_not_a_terminal_definition;
        sym->set_rc(*sf->p2__,__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
       }
    
}

Rt_sufx_phrase::Rt_sufx_phrase(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rt_sufx_phrase",0,Clr1_k_phrase_th::R_Rt_sufx_phrase_,P,false,false){
}

void Rt_sufx_phrase::sr1(){
  struct SF{
   Rlint* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   Rcweb_k* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
   Rlint* p3__;
   State* s3__;
   bool abort3__;
   Rule_s_reuse_entry* rule_s_reuse_entry3__;
   Rt_sufx_kw_must* p4__;
   State* s4__;
   bool abort4__;
   Rule_s_reuse_entry* rule_s_reuse_entry4__;
   Rt_sufx_code* p5__;
   State* s5__;
   bool abort5__;
   Rule_s_reuse_entry* rule_s_reuse_entry5__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(5);
  
    Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
	  fsm->lr1_k_phrase_->lrk_sufx_code()
	  ->add_cweb_marker(sf->p2__->cweb_t_);		
  
}

Rt_sufx_kw_code::Rt_sufx_kw_code(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rt_sufx_kw_code",0,Clr1_k_phrase_th::R_Rt_sufx_kw_code_,P,false,false){
}

Rt_sufx_kw::Rt_sufx_kw(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rt_sufx_kw",0,Clr1_k_phrase_th::R_Rt_sufx_kw_,P,false,false){
}

void Rt_sufx_kw::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_lrk_sufx* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
         sf->p2__->set_auto_delete(true);
      
}

Rt_sufx_kw_must::Rt_sufx_kw_must(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rt_sufx_kw_must",0,Clr1_k_phrase_th::R_Rt_sufx_kw_must_,P,false,false){
}

void Rt_sufx_kw_must::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_lrk_sufx* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
         sf->p2__->set_auto_delete(true);
      
}

void Rt_sufx_kw_must::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
          CAbs_lr1_sym* sym = new Err_missing_lrk_sufx_kw;
          sym->set_rc(*sf->p2__,__FILE__,__LINE__);
          RSVP(sym);
          sf->p2__->set_auto_delete(true);
          rule_info__.parser__->set_stop_parse(true);
      
}

void Rt_sufx_kw_must::sr3(){
  struct SF{
   CAbs_lr1_sym* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(1);
  
          CAbs_lr1_sym* sym = new Err_missing_lrk_sufx_kw;
          sym->set_rc(*sf->p1__,__FILE__,__LINE__);
          RSVP(sym);
          rule_info__.parser__->set_stop_parse(true);
          return;
     
}

Rt_sufx_code::Rt_sufx_code(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rt_sufx_code",0,Clr1_k_phrase_th::R_Rt_sufx_code_,P,false,false){
}

void Rt_sufx_code::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_syntax_code* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
        Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
        fsm->lr1_k_phrase_->lrk_sufx_code(sf->p2__);
      
}

void Rt_sufx_code::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
          CAbs_lr1_sym* sym = new Err_no_syntax_code_present;
          sym->set_rc(*sf->p2__,__FILE__,__LINE__);
          RSVP(sym);
          sf->p2__->set_auto_delete(true);
          rule_info__.parser__->set_stop_parse(true);
      
}

void Rt_sufx_code::sr3(){
  
          CAbs_lr1_sym* sym = new Err_no_syntax_code_present;
          sym->set_rc(*rule_info__.parser__->start_token__,__FILE__,__LINE__);
          RSVP(sym);
          rule_info__.parser__->set_stop_parse(true);
      
}

Ropen_brace::Ropen_brace(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Ropen_brace",0,Clr1_k_phrase_th::R_Ropen_brace_,P,false,false){
}

void Ropen_brace::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_open_brace;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rclose_brace::Rclose_brace(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rclose_brace",0,Clr1_k_phrase_th::R_Rclose_brace_,P,false,false){
}

void Rclose_brace::sr1(){
  
        CAbs_lr1_sym* sym = new Err_no_close_brace;
        sym->set_rc(*rule_info__.parser__->current_token(),__FILE__,__LINE__);
        RSVP(sym);
        rule_info__.parser__->set_stop_parse(true);
      
}

Rlint::Rlint(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rlint",0,Clr1_k_phrase_th::R_Rlint_,P,false,false){
}

Rcweb_k::Rcweb_k(yacco2::Parser* P)
 :CAbs_lr1_sym
  ("Rcweb_k",0,Clr1_k_phrase_th::R_Rcweb_k_,P,false,false){
}

void Rcweb_k::ctor(){
 
	  cweb_t_ = 0;
	
}
void Rcweb_k::sr1(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   T_cweb_comment* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
  
       Clr1_k_phrase_th* fsm = (Clr1_k_phrase_th*)rule_info__.parser__->fsm_tbl__;
      T_cweb_comment* k = sf->p2__;
      AST* cwebk_t_ = new AST(*k);
      cweb_t_ = new AST();
      T_cweb_marker* cw = new T_cweb_marker(cweb_t_);
      cw->set_rc(*k,__FILE__,__LINE__);
        cweb_t_ = cw->ast();
      AST::set_content(*cweb_t_,*cw);
        AST::join_pts(*cweb_t_,*cwebk_t_);
  
}

void Rcweb_k::sr2(){
  struct SF{
   LR1_parallel_operator* p1__;
   State* s1__;
   bool abort1__;
   Rule_s_reuse_entry* rule_s_reuse_entry1__;
   CAbs_lr1_sym* p2__;
   State* s2__;
   bool abort2__;
   Rule_s_reuse_entry* rule_s_reuse_entry2__;
  };
  SF* sf = (SF*)rule_info__.parser__->parse_stack__.sf_by_top(2);
   
		RSVP(sf->p2__);
		rule_info__.parser__->set_stop_parse(true); 
      
}

